/*
Copyright 2009,2010 by Fabian Schwartau
E-Mail: fabian@opencode.eu

This file is part of HM2PC.

HM2PC is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

HM2PC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with HM2PC  If not, see <http://www.gnu.org/licenses/>.
*/

#include "uart.h"
#include "Sleep.h"
#include "HamegProtocol.h"
#include "adc.h"

void pinsOutput();
void pinsTristate();

int main()
{
	uart_init();
	sei();
	sleep_10ms(10);
	Channel currentChannel=tristate;
	while(1)
	{
		switch(uart_getc())
		{
			uart_putcc("bla");
			case 0x00:  // test request
				uart_putc(0xF0);  // answer correct byte
				break;
			
			case 0x01:  // Read single screenshot, 2048 Bytes
				currentChannel=uart_getc();
				HMSetChannel(currentChannel);
				HMSendScreenshot();
				break;
			
			case 0x02:  // Read continous screenshots, each 2048 Bytes, 0x00 between each one
				currentChannel=uart_getc();
				uint16_t sleeptime=uart_getc()<<8;
				sleeptime+=uart_getc();
				HMSetChannel(currentChannel);
				while(uart_get_noblock()!=0x03)  // Stop screenshots after the current one is finished
				{
					HMSendScreenshot();
					uart_putc(0x00);
					uart_putc(0xEE);
					uart_putc(0x15);
					sleep_1ms(sleeptime);
				}
				break;
			
			case 0x04: // Read Channel selection
				uart_putc(HMGetChannel());
				HMSetChannel(currentChannel);
				break;
			
			case 0x05: // Set channel selection, will be overwritten by a read command!
				currentChannel=uart_getc();
				HMSetChannel(currentChannel);
				break;
		}
	}

}

