/*
Copyright 2009,2010 by Fabian Schwartau
E-Mail: fabian@opencode.eu

This file is part of HM2PC.

HM2PC is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

HM2PC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with HM2PC  If not, see <http://www.gnu.org/licenses/>.
*/

#include "HamegProtocol.h"

void HMSetChannel(Channel value)
{
	switch(value)
	{
		case tristate:
			CHSEL_DDR &= ~(1<<CHSEL_PIN);
			CHSEL_PORTOUT &= ~(1<<CHSEL_PIN);
			break;
		case one:
			CHSEL_DDR |= (1<<CHSEL_PIN);
			CHSEL_PORTOUT |=  (1<<CHSEL_PIN);
			break;
		case two:
			CHSEL_DDR |= (1<<CHSEL_PIN);
			CHSEL_PORTOUT &= ~(1<<CHSEL_PIN);
			break;
	}
}


void HMSendScreenshot()
{
	RESAZ_DDR   |= (1<<RESAZ_PIN);
	CLAC_DDR    |= (1<<CLAC_PIN);
	SRQ_DDR     |= (1<<SRQ_PIN);

	CLAC_PORT  &= ~(1<<CLAC_PIN);
	SRQ_PORT   |=  (1<<SRQ_PIN);
	RESAZ_PORT   &= ~(1<<RESAZ_PIN);
	//sleep_10ms(10);
	RESAZ_PORT   |=  (1<<RESAZ_PIN);
	//sleep_1ms(10);
	uint16_t i;
	for(i=0; i<2048; i++)
	{
		CLAC_PORT   |=  (1<<CLAC_PIN);
		sleep_1us(1);
		uart_putc(DATA_PORT);
		CLAC_PORT  &= ~(1<<CLAC_PIN);
		sleep_1us(1);
	}
	RESAZ_DDR &= ~(1<<RESAZ_PIN);
	CLAC_DDR  &= ~(1<<CLAC_PIN);
	SRQ_DDR   &= ~(1<<SRQ_PIN);
	SRQ_PORT  &= ~(1<<SRQ_PIN);
	//sleep_10ms(500);
}

Channel HMGetChannel()
{	
	HMSetChannel(tristate);
	sleep_10ms(1);
	uint8_t hadHigh=0;
	uint8_t hadLow=0;
	uint8_t i;
	for(i=0; i<30; i++)
	{
		if(CHSEL_PORTIN&(1<<CHSEL_PIN))
			hadHigh=1;
		else
			hadLow=1;
		sleep_1ms(1);
	}
	if(hadHigh && hadLow)
		return tristate;
	else if(hadHigh)
		return one;
	else
		return two;
}


