/*
Copyright 2009,2010 by Fabian Schwartau
E-Mail: fabian@opencode.eu

This file is part of HM2PC.

HM2PC is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

HM2PC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with HM2PC  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _HAMEGPROTOCOL_H_
#define _HAMEGPROTOCOL_H_

#include <avr/interrupt.h>
#include <stdio.h>
#include <stdlib.h>
#include <avr/io.h>
#include "uart.h"
#include "Sleep.h"
#include "adc.h"

// INPUTS
#define DATA_PORT    PINC

// OUTPUTS
#define CHSEL_DDR    DDRA   // Kanalsekektierung und Kanalausgabe wenn Tri-State (analog auslesen!)
#define CHSEL_PORTOUT  PORTA
#define CHSEL_PORTIN   PINA
#define CHSEL_PIN    7
#define RESAZ_DDR    DDRA   // Auslese Zhler zurcksetzen
#define RESAZ_PORT   PORTA
#define RESAZ_PIN    6
#define CLAC_DDR     DDRA   // 
#define CLAC_PORT    PORTA
#define CLAC_PIN     5
#define SRQ_DDR      DDRA   // Bedienungsanforderung
#define SRQ_PORT     PORTA
#define SRQ_PIN      4
#define LSING_DDR    DDRD   // 
#define LSING_PORT   PORTD
#define LSING_PIN    3
#define CLRSING_DDR  DDRD   // 
#define CLRSING_PORT PORTD
#define CLRSING_PIN  2

typedef enum EnChannel
{
	one=0x01,
	two=0x02,
	tristate=0x03

} Channel;

void HMSetChannel(Channel value);
void HMSendScreenshot();
Channel HMGetChannel();

#endif

