/*
Copyright 2009,2010 by Fabian Schwartau
E-Mail: fabian@opencode.eu

This file is part of HM2PC.

HM2PC is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

HM2PC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with HM2PC.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "ComPort.h"
#include <QtGui/QMessageBox>

ComPort::ComPort():
Connected(false)
{
	
}

ComPort::~ComPort()
{
	
}

int ComPort::open(QString Port, QString Baud)
{
	if(Connected)
		close();
	this->HCom=CreateFileA(Port.toStdString().c_str(), GENERIC_READ | GENERIC_WRITE , 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if(this->HCom==INVALID_HANDLE_VALUE)
		return CREATEFILE;
	if(!SetupComm(this->HCom, 4096, 4096))
		return SETUPCOMM;
	if(!PurgeComm(this->HCom, PURGE_RXABORT | PURGE_RXCLEAR | PURGE_TXABORT | PURGE_TXCLEAR))
		return PURGECOMM;
	if(!GetCommState(this->HCom, &DCBstruct))
		return GETCOMMSTATE;
	QString CommDCBStr=Port+": baud="+Baud+" parity=N data=8 stop=1 to=off xon=off odsr=off octs=off dtr=off rts=off idsr=off";
	if(!BuildCommDCBA(CommDCBStr.toStdString().c_str(), &this->DCBstruct))
		return BUILDCOMMDCB;
	if(!SetCommState(this->HCom, &this->DCBstruct))
		return SETCOMMSTATE;
	this->Connected=true;
	return OK;
}

void ComPort::close()
{
	CloseHandle(this->HCom);
	this->Connected=false;
}

bool ComPort::isOpen()
{
	return this->Connected;
}

int ComPort::write(char* Data, int Length)
{
	DWORD Written=0;
	if(WriteFile(this->HCom, Data, Length, &Written, NULL))
		return WRITEFILE;
	else
		return OK;
}

int ComPort::read(char *Data, int toRead)
{
	DWORD Readed=0;
	if(ReadFile(this->HCom, Data, toRead, &Readed, NULL)>0)
	{
		return Readed;
	}
	return -1;
}


