/*
Copyright 2009,2010 by Fabian Schwartau
E-Mail: fabian@opencode.eu

This file is part of HM2PC.

HM2PC is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

HM2PC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with HM2PC.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _COMPORT_H_
#define _COMPORT_H_

#include <QtCore/QString>
#include <windows.h>

enum COMERROR
{
	OK = 0,
	CREATEFILE,
	SETUPCOMM,
	PURGECOMM,
	GETCOMMSTATE,
	BUILDCOMMDCB,
	SETCOMMSTATE,
	WRITEFILE
};

class ComPort
{
public:
	ComPort();
	~ComPort();
	int open(QString Port, QString Baud);
	void close();
	bool isOpen();
	int write(char* Data, int Length);
	int read(char* Data, int toRead);

private:
	HANDLE HCom;
	DCB DCBstruct;
	bool Connected;
};

#endif
