/*
Copyright 2009,2010 by Fabian Schwartau
E-Mail: fabian@opencode.eu

This file is part of HM2PC.

HM2PC is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

HM2PC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with HM2PC.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "HamegInterface.h"

#include <QtGui/QMessageBox>

HamegInterface::HamegInterface()
{
	
}

HamegInterface::~HamegInterface()
{
	
}

int HamegInterface::openCom(QString port, QString baud)
{
	return com.open(port, baud);
}

void HamegInterface::closeCom()
{
	com.close();
}

bool HamegInterface::checkConnection()
{
	char command[]="\x00";
	char answer[5];
	com.write(command, 1);
	int readed=read(answer, 1);
	if(readed!=1)
		return false;
	if((unsigned char)answer[0]==0xf0)
		return true;
	else
		return false;
}

int HamegInterface::getSingleShot(char* data)
{
	char command[]="\x01\x03";
	com.write(command, 2);
	int readed=read(data, 2048);
	char cmdRelease[]="\x05\x03";  // This is just a bug fix, this should be automatic done by the atmega ;)
	com.write(cmdRelease, 2);
	if(readed!=2048)
		return false;
	else
		return true;
}

int HamegInterface::read(char* data, int size, int timeout)
{
	unsigned int readedTotal=0;
	for(int i=0; i<(timeout/10)+1;i++)  // make sure we will read at least one time!
	{
		int readed=com.read(data+readedTotal, size-readedTotal);
		readedTotal+=readed;
		if(readedTotal==size)
			break;
		Sleep(10);
	}
	return readedTotal;
}

