/*
Copyright 2009,2010 by Fabian Schwartau
E-Mail: fabian@opencode.eu

This file is part of HM2PC.

HM2PC is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

HM2PC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with HM2PC.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _HAMEGINTERFACE_H_
#define _HAMEGINTERFACE_H_

#include "ComPort.h"
#include <fstream>
#include <QtGui/QMessageBox>

using namespace std;

enum HamegStatus
{
	standby,
	loadingImage
};

class HamegInterface
{
public:
	HamegInterface();
	virtual ~HamegInterface();
	
	void run();

	int openCom(QString port, QString baud);
	void closeCom();

	int read(char* data, int size, int timeout=1000);
	
	int getSingleShot(char* data);
	bool checkConnection();

private:
	ComPort com;
};

#endif