/*
Copyright 2009,2010 by Fabian Schwartau
E-Mail: fabian@opencode.eu

This file is part of HM2PC.

HM2PC is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

HM2PC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with HM2PC.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef MAINWND_H_
#define MAINWND_H_

#include "ui_MainWnd.h"
#include "ComPort.h"
#include "RenderArea.h"
#include "HamegInterface.h"
#include <QtCore/QTimer>
#include <QtCore/QTime>

class MainWnd : public QMainWindow, protected Ui_MainWnd
{
	Q_OBJECT
public:
	MainWnd(QWidget* parent = 0, Qt::WFlags flags = 0);
	virtual ~MainWnd();

private:
	void resizeEvent(QResizeEvent* event);
	void refreshScreen();

	QTimer* timerRefresh;
	//ComPort comPort;
	QTime time;
	//int received;
	RenderArea renderArea;
	QStatusBar* statusBar;
	HamegInterface hameg;
	char *screenData;
private slots:
	void onButtonOpen();
	void onButtonClose();
	void onButtonSaveImage();
	void onButtonRefresh();
	void onTimerRefresh();
	void onImageSaveTypeChanged();
	void onRefreshModeChanged();
	void onRefreshRateChanged(QString newValue);
};
#endif