/*
Copyright 2009,2010 by Fabian Schwartau
E-Mail: fabian@opencode.eu

This file is part of HM2PC.

HM2PC is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

HM2PC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with HM2PC.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "RenderArea.h"
#include <QtGui/QMessageBox>

RenderArea::RenderArea(QWidget* parent) :
//QWidget(parent),
QFrame(parent),
screenData(NULL)
{
	this->setGeometry(20,150,200,200);
	/*setFrameStyle(QFrame::Box | QFrame::Raised);
	setLineWidth(2);
	setMidLineWidth(2);
	setFrameShadow(QFrame::Plain);
	setFrameShape(QFrame::Box);*/
}

RenderArea::~RenderArea()
{
	
}

void RenderArea::paintEvent(QPaintEvent*)
{
	repaintLines(this);
	QPainter painter(this);
	painter.setPen(Qt::gray);
	painter.setBrush(Qt::NoBrush);
	painter.drawRect(QRect(0, 0, width() - 1, height() - 1));
}

void RenderArea::repaintLines(QPaintDevice* device)
{
	QPainter painter(device);
	painter.setRenderHint(QPainter::Antialiasing, false);
	painter.setPen(Qt::white);
	painter.fillRect(0, 0, device->width(), device->height(), Qt::white);
	if(!screenData)
		return;
	painter.setPen(Qt::black);
	for(int i=1; i<2048;i++)
	{
		unsigned int value1=(unsigned int)((unsigned char)screenData[i-1]);
		value1=device->height()-value1*device->height()/255;
		unsigned int value2=(unsigned int)((unsigned char)screenData[i]);
		value2=device->height()-value2*device->height()/255;
		painter.drawLine(device->width()*(i-1)/2048, value1, device->width()*(i)/2048, value2);
	}
}

void RenderArea::setScreenData(char* screenData)
{
	this->screenData=screenData;
	this->repaint();
}

void RenderArea::saveToImage(QString fileName, int width, int height)
{
	//QPixmap pixmap= QPixmap::grabWindow(winId());   // FIXME: this is not very porable
	//pixmap.save(fileName);

	QImage image(width, height, QImage::Format_RGB32);
	repaintLines(&image);
	if(!image.save(fileName))
		QMessageBox::information(this, "Saving image failed", "Failed to save image, maybe you don't have permission to write this file.");
}




